<?php

namespace Drupal\view_mode_switch\Plugin\Field\FieldType;

use Drupal\Core\Field\FieldItemList;

/**
 * Defines an item list class for view mode switch fields.
 *
 * @see \Drupal\view_mode_switch\Plugin\Field\FieldType\ViewModeSwitchItem
 */
class ViewModeSwitchItemList extends FieldItemList implements ViewModeSwitchItemListInterface {

  /**
   * {@inheritdoc}
   */
  public function getAllowedViewModes() {
    /* @var \Drupal\view_mode_switch\Plugin\Field\FieldType\ViewModeSwitchItemInterface $item */
    $item = $this->first() ?: $this->createItem();

    return $item->getAllowedViewModes();
  }

  /**
   * {@inheritdoc}
   */
  public function getViewMode() {
    if (!$this->isEmpty()) {
      /* @var \Drupal\view_mode_switch\Plugin\Field\FieldType\ViewModeSwitchItemInterface $item */
      $item = $this->first();

      return $item->getViewMode();
    }

    return NULL;
  }

  /**
   * {@inheritdoc}
   */
  public function getOriginViewModes() {
    /* @var \Drupal\view_mode_switch\Plugin\Field\FieldType\ViewModeSwitchItemInterface $item */
    $item = $this->first() ?: $this->createItem();

    return $item->getOriginViewModes();
  }

  /**
   * {@inheritdoc}
   */
  public function isApplicable($view_mode) {
    if (!$this->isEmpty()) {
      /* @var \Drupal\view_mode_switch\Plugin\Field\FieldType\ViewModeSwitchItemInterface $item */
      $item = $this->first();

      return $item->isApplicable($view_mode);
    }

    return FALSE;
  }

  /**
   * {@inheritdoc}
   */
  public function isResponsible($view_mode) {
    /* @var \Drupal\view_mode_switch\Plugin\Field\FieldType\ViewModeSwitchItemInterface $item */
    $item = $this->first() ?: $this->createItem();

    return $item->isResponsible($view_mode);
  }

}
