<?php

namespace Drupal\Tests\view_mode_switch\Kernel;

use Drupal\entity_test\Entity\EntityTest;

/**
 * Tests the 'View mode switch' field type formatters.
 *
 * @group view_mode_switch
 * @see \Drupal\view_mode_switch\Plugin\Field\FieldFormatter\ViewModeSwitchDefaultFormatter
 * @see \Drupal\view_mode_switch\Plugin\Field\FieldFormatter\ViewModeSwitchMachineNameFormatter
 */
class ViewModeSwitchFormattersTest extends ViewModeSwitchTestBase {

  /**
   * Tests the built-in formatters.
   */
  public function testFormatter() {
    $entity = EntityTest::create();
    $entity->{$this->fieldFoo->getName()}->value = 'foo1';

    $items = $entity->get($this->fieldFoo->getName());

    // Test 'Default' formatter.
    $build = $items->view();
    $this->assertEqual($build['#formatter'], 'view_mode_switch_default', 'Ensure to fall back to the default formatter.');
    $this->assertEqual($build[0]['#markup'], 'foo1 label');

    // Test 'Machine name' formatter.
    $build = $items->view(['type' => 'view_mode_switch_machine_name']);
    $this->assertEqual($build['#formatter'], 'view_mode_switch_machine_name', 'The chosen formatter is used.');
    $this->assertEqual((string) $build[0]['#markup'], 'foo1');
  }

}
